/* This file has been automatically generated by builder part of the ferite distribution */
/* file:  reflection_Function.c */
/* class: Function */

#include <ferite.h>       /* we need this without a doubt */
#include "reflection_header.h"  /* this is the module header */

FE_NATIVE_FUNCTION( reflection_Function_exec_E )
{
   FeriteObject *self = VAO(params[ferite_get_parameter_count(params) - 1]);

   ferite_get_parameters( params, 0 );

   { /* Main function body. */
#line 559 "reflection.fec"

   
       FeriteVariable *var, *ss, *se, *dup;
       FeriteVariable **np;
       int i = 0;
       int cp = ferite_get_parameter_count(params)-2;
       np = ferite_create_parameter_list(cp+3);

       for(i = 0; i < cp ; i++)
       {
           FUD(("number of real params: '%d'\n",cp));
           var = ferite_get_parameter(params,i);
           FUD(("param %d: '%s' type '%s'\n",i,var->name, ferite_variable_id_to_str(script,var->type)));
           if(var->type == F_VAR_STR)
           {
               FUD(("\tvalue='%s'\n",VAS(var)));
           }
           dup = ferite_duplicate_variable( script, var, NULL);
           MARK_VARIABLE_AS_DISPOSABLE(dup);
           ferite_add_to_parameter_list(np,dup);
       }

       if(FunctionObj->obj != NULL )
         np = ferite_object_add_self_variable_to_params( script, np, FunctionObj->obj);

       FUD(("arg count: '%d'\n",FunctionObj->func->arg_count));
       FUD(("calling '%s'...\n",FunctionObj->func->name));
       dup = ferite_call_function(script,FunctionObj->func,np);
       ferite_delete_parameter_list(script,np);
       FUD(("finished\n"));

       FE_RETURN_VAR(dup);
   
   }
   FE_RETURN_VOID;
}

FE_NATIVE_FUNCTION( reflection_Function_execWithArray_a )
{
   FeriteUnifiedArray *args;
   FeriteObject *super;
   FeriteObject *self;

   ferite_get_parameters( params, 3, &args, &super, &self );

   { /* Main function body. */
#line 606 "reflection.fec"

   
       FeriteVariable **plist = ferite_create_parameter_list( args->size + 3 );
       FeriteVariable *rval = NULL;
       int i = 0;
       
       for( i = 0; i < args->size; i++ )
	 plist[i] = ferite_duplicate_variable( script, args->array[i], NULL );
       
       if( FunctionObj->obj != NULL )
	 plist = ferite_object_add_self_variable_to_params( script, plist, FunctionObj->obj );
       
       rval = ferite_call_function( script, FunctionObj->func, plist );
       ferite_delete_parameter_list( script, plist );
	   
       FE_RETURN_VAR( rval );
   
   }
   FE_RETURN_VOID;
}

FE_NATIVE_FUNCTION( reflection_Function_Function_os )
{
   FeriteObject *o;
   FeriteString *f;
   FeriteObject *super;
   FeriteObject *self;

   ferite_get_parameters( params, 4, &o, &f, &super, &self );

   { /* Main function body. */
#line 529 "reflection.fec"

   
       FunctionObj = fmalloc( sizeof( FunctionHolder ) );
       FunctionObj->func = ferite_object_get_function(script,o,f->data);
       FunctionObj->obj = o;
       
       if( FunctionObj->func == NULL )
       {
	   ffree( FunctionObj );
	   FE_RETURN_NULL_OBJECT;
       }
   
   }
   FE_RETURN_VOID;
}

FE_NATIVE_FUNCTION( reflection_Function_Function_s )
{
   FeriteString *f;
   FeriteObject *super;
   FeriteObject *self;

   ferite_get_parameters( params, 3, &f, &super, &self );

   { /* Main function body. */
#line 513 "reflection.fec"

   
       FeriteNamespaceBucket *nsb = NULL;
       
       FunctionObj = fmalloc( sizeof( FunctionHolder ) );
       FunctionObj->obj = NULL;
       
       nsb = ferite_find_namespace(script,script->mainns,f->data,FENS_FNC);
       if( nsb != NULL )
	 FunctionObj->func = nsb->data;
       else
       {
	   ffree( FunctionObj );
	   FE_RETURN_NULL_OBJECT;
       }
   
   }
   FE_RETURN_VOID;
}

FE_NATIVE_FUNCTION( reflection_Function_Destructor_ )
{
   FeriteObject *super;
   FeriteObject *self;

   ferite_get_parameters( params, 2, &super, &self );

   { /* Main function body. */
#line 542 "reflection.fec"

   
       if( FunctionObj != NULL )
	 ffree(FunctionObj);
   
   }
   FE_RETURN_VOID;
}

FE_NATIVE_FUNCTION( reflection_Function_getParameterDetails_ )
{
   FeriteObject *super;
   FeriteObject *self;

   ferite_get_parameters( params, 2, &super, &self );

   { /* Main function body. */
#line 639 "reflection.fec"

   
       int i = 0, argcount = FunctionObj->func->arg_count;
       FeriteVariable *retval = NULL, *newvar = NULL;
       
       if( FunctionObj->func->klass != NULL && FunctionObj->func->is_static == 0 )
         argcount -= 2;
       
       retval = ferite_create_uarray_variable( script, "Function.getParameterDetails", FunctionObj->func->arg_count, FE_STATIC );
       for( i = 0; i < argcount; i++ )
       {
           if( strcmp( FunctionObj->func->signature[i]->variable->name, "..." ) != 0 )
           {
               newvar = ferite_create_string_variable_from_ptr( script, "", 
                                                                ferite_variable_id_to_str( script, 
                                                                                           FunctionObj->func->signature[i]->variable->type ), 
                                                                0, FE_CHARSET_DEFAULT, FE_STATIC );
           }
           else
             newvar = ferite_create_string_variable_from_ptr( script, "", "...", 0, FE_CHARSET_DEFAULT, FE_STATIC );
           ferite_uarray_add( script, VAUA(retval), newvar, FunctionObj->func->signature[i]->variable->name, FE_ARRAY_ADD_AT_END );
       }
       FE_RETURN_VAR( retval );
   
   }
   FE_RETURN_VOID;
}

